public class Pmodell implements Modell
{
    public int getGleichungsanzahl()
    {
        return 8;      
    }      

    
    public double det(double[][] m)
    {
         return m[0][0]*m[1][1] - m[1][0]*m[0][1];
    }
    
    public void steigung(double[] f, double[] yy,double t)
    {
        double    x1  = yy[6];  //Weg Schlitten
        double    vx1 = yy[7];
    
        double    x2  = yy[0]; //Weg Pendel
        double    y2  = yy[1];
        double    phi = yy[2];

        double    vx2    = yy[3]; 
        double    vy2    = yy[4];
        double    omega  = yy[5];
        
        //REGLER:
        FA = -100.0*phi;

        //Zwangskräfte Fx und Fy bestimmen:
        //QQ*F=q => F = inv(QQ)*q

        double[] q = {-FA/m1-(1/J)*h*Math.cos(phi)*Drot*omega-h*omega*omega*Math.sin(phi),
               -(1/J)*h*Math.sin(phi)*Drot*omega+h*omega*omega*Math.cos(phi)-g};

        double[][] QQ = {{(1/m1)+(1/J)*h*h*Math.cos(phi)*Math.cos(phi)+(1/m2), (1/J)*h*h*Math.sin(phi)*Math.cos(phi)},
                         {(1/J)*h*h*Math.sin(phi)*Math.cos(phi)              , (1/J)*h*h*Math.sin(phi)*Math.sin(phi) + (1/m2)}};

        double[][] QX = {{q[0],QQ[0][1]},{q[1],QQ[1][1]}};
        double[][] QY = {{QQ[0][0],q[0]},{QQ[1][0],q[1]}};

        //F = inv(QQ)*q;
        double detQQ = det(QQ);
        double Fx = det(QX)/detQQ;
        double Fy = det(QY)/detQQ;

        

        //Pendel:
        f[0]=x2;   //Newton x Substitutuion   x2
        f[1]=y2;   //Newton y Substitutuion   y2
        f[2]=omega;   //Euler Substitutuion      phi


        f[3]=-Fx/m2;   //Newton dx2/dt
        f[4]=-Fy/m2-g;   //Newton dy2/dt
        f[5]=(-Drot*omega - h*Math.sin(phi)*Fy -h*Math.cos(phi)*Fx)/J;   //Euler  omega

        //Schlitten:
        f[6]=vx1;   //Newton x Substitutuion   x1

        f[7]=FA/m1 + Fx/m1;   //Newton dx1/dt
    }    
}