

//Wagen:
float wagen_x = 0.0f;

//Pendel:
float pendel_phi = 0.0f;

//Drot = 0.01;
double Drot = 0.0;
double m2   = 1.0;
double l    = 1.0;
double h    = l/2;
double r    = 0.01;
double J    = 0.25*m2*r*r + (1/12)*m2*l*l;

double m1   = 1.0;

double FA   = 0.0;
double g    = 9.81;

double dt = 0.01;
double  t = 0.0;
int anzgl = 8;

double[] y_alt = new double[anzgl];
double[] y_neu = new double[anzgl];

Integrator integrator;
Pmodell   modell;


public void initialisieren()
{
    modell = new Pmodell();
    y_alt = new double[modell.anzahl];
    y_neu = new double[modell.anzahl];
    integrator = new Integrator(modell);
  
  
    y_alt[2] = 0.05*Math.PI;
    y_neu[2] = 0.05*Math.PI;
    
    t = 0.0;
}

public void mouseClicked()
{
    initialisieren();
}

public void setup()
{
    size(800,500);
    
    background(255);
 
    initialisieren();
 
    frameRate(25);
 
       
}

public void zeitschritt()
{
    System.out.print("t="+t+" ");   
    for(int i=0;i<y_alt.length;i++)
    {
        System.out.print("y"+i+"="+y_alt[i]+" ");   
    }
    System.out.println();

    for(int i=0;i<y_alt.length;i++)
        y_alt[i] = y_neu[i];
  
    integrator.zeitschritt(y_neu,y_alt,t,dt); //Ergebnis wird in y gelegt
    
     wagen_x = (float)y_alt[6];
     pendel_phi = (float)y_alt[2];         
    
    t+=dt;   
     
}

public void draw()
{
    clear();
  
    //width = 2m:
//    float bb = 8.0f;
//    float hh = 5.0f;
    float bb = 2.0f;
    float hh = 1.25f;
    float xx = wagen_x*(width/bb) + width*0.5f;
    float yy = height*0.5f;
  
    //Wagen
    float sb = (width/bb)*0.5f; //Schlittenbreite 0.5m
    float sh = (height/hh)*0.2f; //Schlittenhöhe 0.2m
    fill(0,0,255);
    noStroke();
    rect(xx-sb*0.5f,yy-sh*0.5f,sb,sh);
 
  
    //Koordinatenkreuz:
    stroke(255,255,0);
    strokeWeight(width*0.001f);
    noFill();
    line(width*0.5f,0.0f,width*0.5f,height);  
    line(0.0f,height*0.5f,width,0.5f*height);  

    //Pendel
    noFill();
    stroke(255,0,0);
    strokeWeight(width*0.005f);
    line(xx,yy,xx-(float)h*sin(pendel_phi)*width/bb,yy-(float)h*cos(pendel_phi)*height/hh);

    if(modell!=null  && integrator!=null)    
        zeitschritt();
}